uses
  Math, SysUtils, DateUtils;
var
  N, cnt: Integer;
  u, v, w, t, dd: array [1..100] of Integer;

  procedure Load;
  var
    d, m, y, i: Integer;
    d1, d2: TDateTime;
  begin
    Read(N);
    d1 := 0;
    for i := 1 to N do begin
      Read(u[i], v[i], w[i], t[i], d, m, y);
      d2 := EncodeDate(y, m, d);
      dd[i] := DaysBetween(d1, d2) * Sign(d2 - d1);
      //Writeln(dd[i]);
      d1 := d2;
    end;
  end;

  procedure Solve(print: Boolean);
  var
    i, r1, r2, r3: Integer;
    dd1, dd2: Integer;
    b: Boolean;
  begin
    cnt := 0;
    for r1 := 2 to 100 do begin
      for r2 := 2 to 100 do begin
        for r3 := 2 to 100 do begin
          dd1 := 0;
          b := false;
          for i := 1 to N do begin
            b := (r1 < u[i]) or (r2 < v[i]) or (r3 < w[i]);
            if b then break;
            dd2 := u[i] + r1 * (v[i] + r2 * (w[i] + r3 * t[i]));
            b := (i > 1) and (dd2 - dd1 <> dd[i]);
            if b then break;
            dd1 := dd2;
          end;
          if not b then begin
            Inc(cnt);
            {if print then
              Writeln(r1, ' ', r2, ' ', r3);}
           end;
        end;
      end;
    end;
  end;

begin
  AssignFile(input, 'input.txt');
  AssignFile(output, 'output.txt');
  Load;
  Solve(false);
  Writeln(cnt);
  Solve(true);
end.
