#include <algorithm>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

const int max_params = 20;
const int max_days = 3000000;
const int mo[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

int r1, r2, r3, d, m, y;
int params[max_params];
vector<int> pr;

void inc()  
{  
   d++;  
   int maxm = mo[m] + (m == 2 && (!(y%4) && (y%100 || !(y%400))) ? 1 : 0); 
   if (d > maxm) {  
      m++; d = 1;  
      if (m > 12) {  
         y++; m = 1;  
      }  
   }  
}  

int main(int argc, char* argv[])
{
   int i;

   //cout << "stage 0" << endl;

   for (i = 1; i < argc; i++) {
      istringstream ss(argv[i]);
      ss >> params[i];
   }

   //cout << "stage 1" << endl;

   srand(params[1]);
   r1 = params[2];
   r2 = params[3];
   r3 = params[4];
   int n = params[5];

   cout << n << endl;

   //cout << "stage 2" << endl;

   int maxt = max_days / (r1*r2*r3);
   int st = rand();
   for (i = 0; i < n; i++) {
      int x = (rand()*(long long)rand() + rand()) % max_days;
      int u, v, w, t;
      int x1 = x;
      u = x % r1 + 1;
      x /= r1;
      v = x % r2 + 1;
      x /= r2;
      w = x % r3 + 1;
      x /= r3;
      t = x + 1;
      //cout << "x1 = " << x1 << endl;
      cout << u << " " << v << " " << w << " " << t << " ";

      d = 1;
      m = 1;
      y = 1600;
      for (int j = st; j != x1+st; j++)
         inc();

      cout << d << " " << m << " " << y << endl;

      //cout << "cycle " << i << endl;
   }

   return 0;
}
